// File: mpplugin.h
// Copyright (C) 1998 by Fuji Xerox Co., Ltd. All rights reserved.

#ifndef __MPPLUGIN_H__
#define __MPPLUGIN_H__ 1

#ifdef __cplusplus
extern "C"{
#define PLUGGEDIN_EXPORT(retValType) extern "C" __declspec(dllexport) retValType __stdcall 

#else
#define PLUGGEDIN_EXPORT(retValType) __declspec(dllexport) retValType __stdcall 
#define STDEXT 
#endif /* __cplusplus */
	
struct _pluggedin_struct {
	long ps_nPlugVersion;
	const char* ps_pszFunction;
	long ps_execParallel;
	long ps_nFiles;
	const char** ps_pszFiles;
	long *ps_pnPageNumbers;
	const char* ps_pszExecFolder;
	long ps_hwndDWDesk;
};


typedef struct _pluggedin_struct PLUGGEDIN_STRUCT;
#define PLUGGEDIN_REGKEY "Software\\FujiXerox\\MPM3\\MPWS\\PLUGGEDIN"

/* Initialize Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_INITIALIZE)(const char*);
#define PLUGGEDIN_NAME_INITIALIZE "_PLG_Initialize@4"
PLUGGEDIN_EXPORT( long ) PLG_Initialize(const char* cmdName);

/* Finalize Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_FINALIZE)(const char *);
#define PLUGGEDIN_NAME_FINALIZE "_PLG_Finalize@4"
PLUGGEDIN_EXPORT( long ) PLG_Finalize(const char*  cmdName);

/* CanFinalize Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_CANFINALIZE)(const char *);
#define PLUGGEDIN_NAME_CANFINALIZE "_PLG_CanFinalize@4"
PLUGGEDIN_EXPORT( long ) PLG_CanFinalize(const char* cmdName);

/* RequireFiles Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_REQUIREFILES)(const char *);
#define PLUGGEDIN_NAME_REQUIREFILES "_PLG_RequireFiles@4"
PLUGGEDIN_EXPORT( long ) PLG_RequireFiles(const char* cmdName);

/* ExecuteCommand Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_EXECUTECOMMAND)(PLUGGEDIN_STRUCT *);
#define PLUGGEDIN_NAME_EXECUTECOMMAND "_PLG_ExecuteCommand@4"
PLUGGEDIN_EXPORT( long ) PLG_ExecuteCommand(PLUGGEDIN_STRUCT* pPlgStruct);

/* IsParallel Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_ISPARALLEL)(const char *);
#define PLUGGEDIN_NAME_ISPARALLEL "_PLG_IsParallel@4"
PLUGGEDIN_EXPORT( long ) PLG_IsParallel(const char* cmdName);

/* IsCloning Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_ISCLONINGCOMMAND)(const char *);
#define PLUGGEDIN_NAME_ISCLONINGCOMMAND "_PLG_IsCloningCommand@4"
PLUGGEDIN_EXPORT( long ) PLG_IsCloningCommand(const char* cmdName);

/* GetNewClone Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_GETNEWCLONE)(char*, long nBufSize);
#define PLUGGEDIN_NAME_GETNEWCLONE "_PLG_GetNewClone@8"
PLUGGEDIN_EXPORT( long ) PLG_GetNewClone(char* cmdName, long nBufSize);

/* ReleaseClone Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_RELEASECLONE)(const char*);
#define PLUGGEDIN_NAME_RELEASECLONE "_PLG_ReleaseClone@4"
PLUGGEDIN_EXPORT( long ) PLG_ReleaseClone(const char* cmdName);

/* Executable Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_EXECUTABLE)(const char *, long);
#define PLUGGEDIN_NAME_EXECUTABLE "_PLG_Executable@8"
PLUGGEDIN_EXPORT( long ) PLG_Executable(const char* cmdName, long nArgFiles);

/* CanSetProfile Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_CANSETPROFILE)(const char *);
#define PLUGGEDIN_NAME_CANSETPROFILE "_PLG_CanSetProfile@4"
PLUGGEDIN_EXPORT( long ) PLG_CanSetProfile(const char* cmdName);

/* SetProfile Entry*/
typedef long (__stdcall *PLUGGEDIN_PROC_SETPROFILE)(const char *);
#define PLUGGEDIN_NAME_SETPROFILE "_PLG_SetProfile@4"
PLUGGEDIN_EXPORT( long ) PLG_SetProfile(const char* cmdName);

/* GetAppIcon Entry*/
typedef HICON (__stdcall *PLUGGEDIN_PROC_GETCOMMANDICON)(const char *, long);
#define PLUGGEDIN_NAME_GETCOMMANDICON "_PLG_GetCommandIcon@8"
PLUGGEDIN_EXPORT( HICON ) PLG_GetCommandIcon(const char* cmdName, long bNormalSize);

/* EnumerateCommands Entry */
typedef long (__stdcall *PLUGGEDIN_PROC_ENUMERATECOMMANDS)( char*, long, long*	);
#define PLUGGEDIN_NAME_ENUMERATECOMMANDS "_PLG_EnumerateCommands@12"
PLUGGEDIN_EXPORT( long ) PLG_EnumerateCommands( char* cmdNameList, long nBufSize, long* nBufSizeRequired );

#define MAX_PLUGGEDIN_NUMBER 30
#define PLUGGEDIN_VERSION 2


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* __MPPLUGIN_H__*/
